#!/usr/bin/perl
#
#testsyb.pl - Temporary SQL backend to GOmnilist
#Copyright (c) Mohit Muthanna 2000
# 
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, 
#Boston, MA  02111-1307, USA.
#
#Send bug-reports, comments, women to bugs@muthanna.com
#
#
#RCSID: $Id: testsyb.pl,v 1.3 2000/11/20 18:54:40 mohit Exp $

use DBI;
use lib qw(perl5);

$PLATFORM="linux2x86";
chomp ($NCOSERVER=<ARGV>); #"MOHIT";
chomp ($NCOUSER=<ARGV>); #"root";
chomp ($NCOPASSWORD=<ARGV>); "";
$NCOINTERFACES="$ENV{OMNIHOME}/etc/interfaces.$PLATFORM";
chomp ($STATEMENT=<ARGV>); #"select Node, Severity, Summary from alerts.status";
$ENV{OMNIHOME} || ($ENV{OMNIHOME}="/opt/Omnibus");
$ENV{SYBASE} || ($ENV{SYBASE}="$ENV{OMNIHOME}/platform/$PLATFORM");

$dbh = DBI->connect ("dbi:Sybase:server=$NCOSERVER;interfaces=$NCOINTERFACES;", $NCOUSER, $NCOPASSWORD) || die "$DBI::errstr\n";

#Fix select statement

$STATEMENT =~ s/^\s*(.*)\s*$/$1/;
$STATEMENT =~ m/^\s*$/ && ($STATEMENT = "select * from alerts.status");
$STATEMENT =~ m/^order/i && ($STATEMENT = "select * from alerts.status " . $STATEMENT);
$STATEMENT !~ m/^(select|delete|update|insert)/i && ($STATEMENT = "select * from alerts.status where " . $STATEMENT);

my $sth = $dbh->prepare ($STATEMENT) || die "$DBI::errstr\n";

my $rc = $sth->execute || die "$DBI::errstr\n";

(1) && eval {
		print join (", ",  @{$sth->{NAME}}) . "\n";

		while (@row = $sth->fetchrow_array) {
			foreach (@row) {
				s/([^\n]*)\n/$1/;
				print "$_\n";	
			}
		}

	$dbh->disconnect();
	exit (0);
};

print "SERVER ERROR: $DBI::errstr.\n";
print "Statement: $STATEMENT\n";
exit(125);
